# resolve-glob [![NPM version](https://img.shields.io/npm/v/resolve-glob.svg?style=flat)](https://www.npmjs.com/package/resolve-glob) [![NPM monthly downloads](https://img.shields.io/npm/dm/resolve-glob.svg?style=flat)](https://npmjs.org/package/resolve-glob) [![NPM total downloads](https://img.shields.io/npm/dt/resolve-glob.svg?style=flat)](https://npmjs.org/package/resolve-glob) [![Linux Build Status](https://img.shields.io/travis/jonschlinkert/resolve-glob.svg?style=flat&label=Travis)](https://travis-ci.org/jonschlinkert/resolve-glob)

> Ensures that absolute file paths are always returned from a glob pattern or array of glob patterns.

## Install

Install with [npm](https://www.npmjs.com/):

```sh
$ npm install --save resolve-glob
```

## Usage

```js
var glob = require('resolve-glob');
```

See [matched](https://github.com/jonschlinkert/matched) for the full range of features and options.

**async**

```js
glob(['*.js'], function(err, files) {
  console.log(files[0])
  //=> '/Users/jonschlinkert/dev/resolve-glob/index.js'
});
```

**sync**

```js
var files = glob.sync(['*.js']);
console.log(files[0])
//=> '/Users/jonschlinkert/dev/resolve-glob/index.js'
```

### cwd expansion

The following characters are expanded to directories with [resolve-dir](https://github.com/jonschlinkert/resolve-dir) when used as leading characters in `options.cwd`:

* `~`: expanded to the user home directory
* `@`: expanded to global npm modules directory

See [resolve-dir](https://github.com/jonschlinkert/resolve-dir) for more details.

## About

### Related projects

* [has-glob](https://www.npmjs.com/package/has-glob): Returns `true` if an array has a glob pattern. | [homepage](https://github.com/jonschlinkert/has-glob "Returns `true` if an array has a glob pattern.")
* [is-glob](https://www.npmjs.com/package/is-glob): Returns `true` if the given string looks like a glob pattern or an extglob pattern… [more](https://github.com/jonschlinkert/is-glob) | [homepage](https://github.com/jonschlinkert/is-glob "Returns `true` if the given string looks like a glob pattern or an extglob pattern. This makes it easy to create code that only uses external modules like node-glob when necessary, resulting in much faster code execution and initialization time, and a bet")
* [is-valid-glob](https://www.npmjs.com/package/is-valid-glob): Return true if a value is a valid glob pattern or patterns. | [homepage](https://github.com/jonschlinkert/is-valid-glob "Return true if a value is a valid glob pattern or patterns.")

### Contributing

Pull requests and stars are always welcome. For bugs and feature requests, [please create an issue](../../issues/new).

### Building docs

_(This project's readme.md is generated by [verb](https://github.com/verbose/verb-generate-readme), please don't edit the readme directly. Any changes to the readme must be made in the [.verb.md](.verb.md) readme template.)_

To generate the readme, run the following command:

```sh
$ npm install -g verbose/verb#dev verb-generate-readme && verb
```

### Running tests

Running and reviewing unit tests is a great way to get familiarized with a library and its API. You can install dependencies and run tests with the following command:

```sh
$ npm install && npm test
```

### Author

**Jon Schlinkert**

* [github/jonschlinkert](https://github.com/jonschlinkert)
* [twitter/jonschlinkert](https://twitter.com/jonschlinkert)

### License

Copyright © 2017, [Jon Schlinkert](https://github.com/jonschlinkert).
Released under the [MIT License](LICENSE).

***

_This file was generated by [verb-generate-readme](https://github.com/verbose/verb-generate-readme), v0.6.0, on July 20, 2017._